include "console.iol"
include "time.iol"
include "runtime.iol"
include "string_utils.iol"

type ThTypeReq: void {
	.id: string
	.content: undefined 
}

type ThTypeRes: void {
	.id: string
	.content: undefined
}

interface _thInterface {
  OneWay: _thReq( ThTypeReq ), 
  				_thRes( ThTypeRes )
}

interface TimeoutHandler {
  RequestResponse: regularOperation
}

execution{ concurrent }

inputPort TimeoutHandlerService {
Location: "socket://localhost:8000"
Protocol: sodep
Interfaces: TimeoutHandler
}

inputPort Self {
Location: "local"
Protocol: sodep
Interfaces: _thInterface
}

outputPort Self {
Location: "local"
Protocol: sodep
Interfaces: _thInterface
}

cset {
	id: ThTypeRes.id
}

init
{
	getLocalLocation@Runtime()( Self.location )
}

main
{
	[ regularOperation( x )( y ){
		req.content << req;
		csets.id = req.id = new;
		_thReq@Self( req );
		_thRes( res );
		y << res.content
	}]{ nullProcess }
	[ _thReq( req ) ]{
		first = true;
		{
			{ // regular operation
				sleep@Time( 500 )(); synchronized( T ){
					if ( first ){
						println@Console( "returning RESULT" )();
						_thRes@Self( { .id = req.id, .content = "RESULT!" } ); 
						first = false
					}
				} 
			}
			|
			{ // timeout
				sleep@Time( 500 )(); synchronized( T ){
					if ( first ){ 
						println@Console( "returning TIMEOUT" )();
						_thRes@Self( { .id = req.id, .content = "TIMEOUT!" } ); 
						first = false
					}
				} 
			}
		}
	}
} 