include "console.iol"
include "config.iol" // contains the API_KEY to invoke BingSpell services

outputPort BingSpell {
	Location: "socket://api.projectoxford.ai:443/text/v1.0/"
	Protocol: https {
		// .debug = true;
		// .debug.showContent = true;
		.addHeader.header = "Ocp-Apim-Subscription-Key";
		.addHeader.header.value = API_KEY;
		.format = "x-www-form-urlencoded"
	}
	RequestResponse: spellcheck
}

inputPort BingSpellProxy {
	Location: "local"
	OneWay: spellCheck
}

outputPort Invoker {
	Location: "local"
	OneWay: spellCheckResponse
}

main
{
	spellCheck( request );
	Invoker.location = request.location;
  spellcheck@BingSpell( { .text = request.text } )( res );
  spellCheckResponse@Invoker( res.spellingErrors.suggestions.token )
}